type stateT

type testT = stateT -> stateT

val succeed: stateT -> stateT

val fail: string -> string -> stateT -> stateT

val skip: stateT -> stateT

val suite: string -> testT list -> testT

val run: testT -> string

(*' [pathGen n] generates the list of consecutive [Var.t]'s of length [n], starting from [Var.XH]. *)
val pathGen: int -> Var.t list
